"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UserAgentUI = void 0;
function _ui() {
  const data = require("@teambit/ui");
  _ui = function () {
    return data;
  };
  return data;
}
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function () {
    return data;
  };
  return data;
}
function _uaParserJs() {
  const data = _interopRequireDefault(require("ua-parser-js"));
  _uaParserJs = function () {
    return data;
  };
  return data;
}
function _uiFoundationUiHooks() {
  const data = require("@teambit/ui-foundation.ui.hooks.use-user-agent");
  _uiFoundationUiHooks = function () {
    return data;
  };
  return data;
}
function _userAgent() {
  const data = require("./user-agent.aspect");
  _userAgent = function () {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
/**
 * user agent aspect
 */
class UserAgentUI {
  static async provider([uiUi]) {
    const userAgentUi = new UserAgentUI();
    uiUi.registerRenderHooks({
      serverInit: ({
        browser
      }) => {
        const userAgent = new (_uaParserJs().default)(browser.headers['user-agent']);
        return {
          userAgent
        };
      },
      browserInit: () => {
        return {
          userAgent: new (_uaParserJs().default)(window.navigator.userAgent)
        };
      },
      reactContext: UserAgentReactContext
    });
    return userAgentUi;
  }
}
exports.UserAgentUI = UserAgentUI;
_defineProperty(UserAgentUI, "slots", []);
_defineProperty(UserAgentUI, "dependencies", [_ui().UIAspect]);
_defineProperty(UserAgentUI, "runtime", _ui().UIRuntime);
function UserAgentReactContext({
  children,
  renderCtx
}) {
  // @todo - UserAgentProvider needs to be explicitly typed
  return /*#__PURE__*/_react().default.createElement(_uiFoundationUiHooks().UserAgentProvider, {
    value: renderCtx === null || renderCtx === void 0 ? void 0 : renderCtx.userAgent
  }, children);
}
_userAgent().UserAgentAspect.addRuntime(UserAgentUI);

//# sourceMappingURL=user-agent.ui.runtime.js.map